(function ($) {
  Drupal.behaviors.jfu_text_format = {
    attach: function(context, settings) {
      $('.jfu-text-format-container .jfu-tex-formt-delta').one('click', function() {
        var data = $(this).parent().find('input[name=jfu_text_format_value]').val();
        var format = $(this).attr('data_format');

        $(document).ajaxComplete(function (event, jqxhr, settings) {
          if (settings.url.indexOf('jfu/dialog/text-format') !== -1) {
            if (format !== 'plain_text' && format !== 'restricted_html') {
              const interval_id = setInterval(jfuTextFormatSetData, 250, data);

              function jfuTextFormatSetData(data) {
                if ($('.jfu-text-format-dialog .ck-editor__editable').length !== 0) {
                  const dom_editable_element = document.querySelector('.jfu-text-format-dialog .ck-editor__editable');
                  const editor_instance = dom_editable_element.ckeditorInstance;
                  if (data !== '') {
                    editor_instance.setData(data);
                  }
                  else {
                    editor_instance.setData('');
                    editor_instance.editing.view.focus();
                  }

                  clearInterval(interval_id);
                }
              }
            }
            else {
              $('.jfu-text-format-dialog textarea[name="jfu_body[value]"]').val(data);
            }
          }
        });
      });

      $(document).ajaxSend(function(event, jqxhr, settings) {
        if (settings.url.indexOf('jfu/dialog/text-format') !== -1) {
          var element = event.target.activeElement;
          var data_format = element.getAttribute('data_format');
          var url = settings.url;
          url = url + '&data_format=' + data_format;
          settings.url = url;
        }
      });
    }
  }
}(jQuery));